VERSION 5.00
Begin VB.Form FrmPrinc 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Autorun (par Nicolas Henry, http://nhen0039.chez-alice.fr/)"
   ClientHeight    =   4215
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5685
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   281
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   379
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox LstSort 
      Height          =   1815
      Left            =   1080
      Sorted          =   -1  'True
      TabIndex        =   1
      Top             =   1215
      Visible         =   0   'False
      Width           =   3255
   End
   Begin Autorun.CtlCategory Cat 
      Height          =   495
      Index           =   0
      Left            =   0
      TabIndex        =   0
      Top             =   -15
      Width           =   3210
      _ExtentX        =   5662
      _ExtentY        =   820
   End
End
Attribute VB_Name = "FrmPrinc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
    
Private mDoc As New ClsDocument

Private mActions As New Collection

Private mRoot As String

Private Sub Cat_RunItem(Index As Integer, ByVal pItem As String)
    Dim lPrg As Object
    Dim lFileName As String
    Dim lFileNum As Long
    
    lFileNum = FreeFile
    
    For Each lPrg In mActions
        If lPrg.Name = pItem Then
            lFileName = Environ("tmp") + "\autorun.bat"
            
            Open lFileName For Output As #lFileNum
                
                Print #lFileNum, Left$(App.Path, 2)
                Print #lFileNum, "cd """ + Mid$(App.Path, 3) + """"
                Print #lFileNum, mRoot
                
                Print #lFileNum, lPrg.Code
                
            Close #lFileNum
            
            Shell lFileName
            
            Exit For
        End If
    Next
    
End Sub

Private Sub Form_Load()
    'Ouverture du document
    If mDoc.OpenFile("Autorun.xml") = False Then Unload Me
    
    Dim lStr As String
    
    Dim lCol As Collection
    
    Dim lPrg As ClsProgram
    Dim lScr As ClsScript
    
    Dim lNode As ClsNode
    Dim lNode1 As ClsNode
        
    Dim lObj As Object
    
    Dim i As Long
    Dim j As Long

    'Liste des programmes
    For Each lNode In mDoc.Nodes(1).Nodes
        If lNode.Name = "program" Then
            Set lPrg = New ClsProgram
            lPrg.Category = lNode.GetNamedAttribute("category")
            lPrg.Name = lNode.GetNamedAttribute("name")
            lPrg.Code = lNode.Value
            mActions.Add lPrg
        End If
    Next
    
    'Liste des scripts
    For Each lNode In mDoc.Nodes(1).Nodes
        If lNode.Name = "script" Then
            Set lScr = New ClsScript
            lScr.Category = lNode.GetNamedAttribute("category")
            lScr.Name = lNode.GetNamedAttribute("name")
            lPrg.Code = ""
            For Each lNode1 In lNode.Nodes
                If lNode1.Name = "program" Then
                    For Each lPrg In mActions
                        If lPrg.Name = lNode1.GetNamedAttribute("name") Then
                            lScr.Code = lScr.Code + vbCrLf + lPrg.Code
                            Exit For
                        End If
                    Next
                End If
            Next
            mActions.Add lScr
        ElseIf lNode.Name = "root" Then
            mRoot = lNode.Value
        End If
    Next
    
    'Listage des catgories et suppression des doublons
    LstSort.Clear
    
    For Each lObj In mActions
        If lObj.Category <> "" Then LstSort.AddItem lObj.Category
    Next
    
    For i = LstSort.ListCount To 1 Step -1
        For j = i - 1 To 1 Step -1
            If LstSort.List(i) = LstSort.List(j) Then
                LstSort.RemoveItem (i)
                Exit For
            End If
        Next
    Next
    
    'Cration des controles
    For i = 1 To LstSort.ListCount - 1 'ListCount-1 car dernier lment = ""
        lStr = LstSort.List(i)
        Set lCol = New Collection
        
        For Each lObj In mActions
            If lObj.Category = lStr Then
                lCol.Add lObj
            End If
        Next
        
        If i > 1 Then Load Cat(i - 1)
        
        With Cat(i - 1)
            .Init lStr, lCol
            .Visible = True
            If i > 1 Then
                .Top = Cat(i - 2).Top + Cat(i - 2).Height
            Else
                .Top = 0
            End If
            .Left = 0
            .Width = Me.ScaleWidth
        End With
        DoEvents
    Next
    
    'Redim de la form
    i = Me.ScaleHeight
    j = Cat(LstSort.ListCount - 2).Top + Cat(LstSort.ListCount - 2).Height
    
    Do While Me.ScaleHeight > j
        Me.Height = Me.Height - Screen.TwipsPerPixelY
        If i = Me.ScaleHeight Then
            Exit Do
        End If
        i = Me.ScaleHeight
    Loop
    
    Do While Me.ScaleHeight < j
        Me.Height = Me.Height + Screen.TwipsPerPixelY
        If i = Me.ScaleHeight Then
            Exit Do
        End If
        i = Me.ScaleHeight
    Loop
    
    Me.Top = 0
    Me.Left = (Screen.Width - Me.Width) / 2
End Sub
