VERSION 5.00
Begin VB.UserControl CtlCategory 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   Begin VB.ListBox LstPrg 
      Height          =   255
      Left            =   600
      Sorted          =   -1  'True
      TabIndex        =   1
      Top             =   780
      Width           =   2715
   End
   Begin VB.Label LblCat 
      Alignment       =   2  'Center
      Caption         =   "%cat%"
      Height          =   225
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2985
   End
End
Attribute VB_Name = "CtlCategory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit


Public Event RunItem(ByVal pItem As String)


Private Sub LstPrg_DblClick()
    RaiseEvent RunItem(LstPrg.List(LstPrg.ListIndex))
End Sub

Private Sub UserControl_Resize()
    With LblCat
        .Top = 0
        .Left = 0
        .Width = UserControl.ScaleWidth
        .Height = 14
    End With
    With LstPrg
        .Top = LblCat.Height
        .Left = 0
        .Width = LblCat.Width
    End With
    Do While UserControl.ScaleHeight > LstPrg.Top + LstPrg.Height
        UserControl.Height = UserControl.Height - Screen.TwipsPerPixelY
    Loop
    Do While UserControl.ScaleHeight < LstPrg.Top + LstPrg.Height
        UserControl.Height = UserControl.Height + Screen.TwipsPerPixelY
    Loop
End Sub

Public Sub Init(ByVal pCat As String, ByVal pPrograms As Collection)
    LblCat.Caption = pCat
    Do While pPrograms.Count > 0
        LstPrg.AddItem pPrograms(1).Name
        pPrograms.Remove 1
    Loop
    
    LstPrg.Height = (LstPrg.ListCount * (LstPrg.Height - 4)) + 4
    
    UserControl_Resize
End Sub
